import 'dart:async';

import 'package:flutter/services.dart';
import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';

typedef List<Widget> CreateWidgetList();

class WMHPickerView extends Dialog {
  List<Map> pickerData;
  List<String> selectedArr = [];
  final callBack;
  bool showPicker;
  Color cancelBtnColor;
  Color confirmBtnColor;
  Color pickerBackgroundColor;
  Color pickerTextColor;
  double textSize;
  double pickerHeight;

  bool isDatePicker;
  int maxYear;
  int minYear;

  int selectYear;
  int selectMonth;
  int selectDay;

  WMHPickerView({Key key,
    this.pickerData,
    this.callBack,
    this.showPicker,
    this.cancelBtnColor,
    this.confirmBtnColor,
    this.pickerBackgroundColor,
    this.pickerTextColor,
    this.textSize,
    this.pickerHeight,
    this.isDatePicker,
    this.maxYear,
    this.minYear,
    this.selectYear,
    this.selectMonth,
    this.selectDay,
  }) : super(key : key);

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return wmhPickerStateful(pickerData: this.pickerData,
      callBack: this.callBack,
    showPicker: this.showPicker,
    cancelBtnColor: this.cancelBtnColor,
    confirmBtnColor: this.confirmBtnColor,
    pickerBackgroundColor: this.pickerBackgroundColor,
    pickerTextColor: this.pickerTextColor,
    textSize: this.textSize,
    pickerHeight: this.pickerHeight,
    isDatePicker: this.isDatePicker,
    maxYear: this.maxYear,
    minYear: this.minYear,
    selectYear: this.selectYear,
    selectMonth: this.selectMonth,
    selectDay: this.selectDay);
  }
}

class wmhPickerStateful extends StatefulWidget {
  List<Map> pickerData;
  List<String> selectedArr = [];
  final callBack;
  bool showPicker;
  Color cancelBtnColor;
  Color confirmBtnColor;
  Color pickerBackgroundColor;
  Color pickerTextColor;
  double textSize;
  double pickerHeight;

  bool isDatePicker;
  int maxYear;
  int minYear;

  int selectYear;
  int selectMonth;
  int selectDay;

  wmhPickerStateful({Key key,
    this.pickerData,
    this.callBack,
    this.showPicker,
    this.cancelBtnColor,
    this.confirmBtnColor,
    this.pickerBackgroundColor,
    this.pickerTextColor,
    this.textSize,
    this.pickerHeight,
    this.isDatePicker,
    this.maxYear,
    this.minYear,
    this.selectYear,
    this.selectMonth,
    this.selectDay,
  }) : super(key : key);

  wmhPickerState createState() => wmhPickerState(
    this.pickerData,
    this.callBack,
    this.showPicker,
    this.cancelBtnColor,
    this.confirmBtnColor,
    this.pickerBackgroundColor,
    this.pickerTextColor,
    this.textSize,
    this.pickerHeight,
    this.isDatePicker,
    this.maxYear,
    this.minYear,
  );
}

class wmhPickerState extends State<wmhPickerStateful> {
  List<Map> pickerData;
  List<String> selectedArr = [];
  var callBack;
  bool showPicker;
  Color cancelBtnColor;
  Color confirmBtnColor;
  Color pickerBackgroundColor;
  Color pickerTextColor;
  double textSize;
  double pickerHeight;
  bool isDatePicker;
  int maxYear;
  int minYear;

  List yearArr = [];
  List monthArr = [];
  int lastYearIndex = 0;
  int lastMonthIndex = 0;
  int lastDayIndex = 0;

  FixedExtentScrollController controller;

  wmhPickerState(
      this.pickerData,
      this.callBack,
      this.showPicker,
      this.cancelBtnColor,
      this.confirmBtnColor,
      this.pickerBackgroundColor,
      this.pickerTextColor,
      this.textSize,
      this.pickerHeight,
      this.isDatePicker,
      this.maxYear,
      this.minYear,
      );

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();
  }

  @override
  void initState() {
    int haveDay = 0;
    if (this.isDatePicker == true) {
      var yearArr = [];
      for (var i = maxYear; i >= minYear; i--) {
        yearArr.add(i);
      }
      this.yearArr = yearArr;
      var monthArr = [];
      for (var i = 1; i <= 12; i++) {
        monthArr.add(i);
      }
      this.monthArr = monthArr;

      var dayArr = [];
      for (var i = 1; i <= getDaysNum(yearArr[0], monthArr[0]); i++) {
        if (i == widget.selectDay) {
          haveDay = i - 1;
        }
        dayArr.add(i);
      }

      this.pickerData = [
        {'subDatas' : yearArr},
        {'subDatas' : monthArr},
        {'subDatas' : dayArr},
      ];
    }

    if (widget.selectDay > 0 && widget.selectMonth > 0 && widget.selectYear > 0) {
      selectedArr = [
        widget.selectYear.toString(),
        widget.selectMonth.toString(),
        widget.selectDay.toString()];
    }

    controller = new FixedExtentScrollController(initialItem:widget.selectDay > 0 ? haveDay : 0);
    super.initState();
  }

  /*根据年份月份获取当前月有多少天*/
  int getDaysNum(int y, int m) {
    if (m == 1 || m == 3 || m == 5 || m == 7 || m == 8 || m == 10 || m == 12) {
      return 31;
    } else if (m == 2) {
      if (((y % 4 == 0) && (y % 100 != 0)) || (y % 400 == 0)) {
        //闰年 2月29
        return 29;
      } else {
        //平年 2月28
        return 28;
      }
    } else {
      return 30;
    }
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return GestureDetector(
      onTap: () {
        Navigator.pop(context);
      },
      child: Material(
        type: MaterialType.transparency,
        child: Container(
          width: MediaQuery.of(context).size.width,
          height: MediaQuery.of(context).size.height,
          alignment: Alignment.bottomCenter,
          child: Container(
            width: MediaQuery.of(context).size.width,
            height: this.pickerHeight,
            color: this.pickerBackgroundColor,
            child: Container(
              child: Column(
                children: <Widget>[
                  _buttonVIew(context),
                  Row(
                    children: _getColumnPicker(context),
                  ),
                ],
              ),
            ),
          ),
        ),
      ),
    );
  }

  _getColumnPicker(BuildContext context) {
    List<Widget> pickerColumnArr = [];
    for (var i = 0; i < this.pickerData.length; i++) {
      Map model = this.pickerData[i];
      if (selectedArr.length == this.pickerData.length) {
        selectedArr = [];
      }
      if (this.isDatePicker == true) {
        if (widget.selectDay > 0 && widget.selectMonth > 0 && widget.selectYear > 0) {
          selectedArr = [
            widget.selectYear.toString(),
            widget.selectMonth.toString(),
            widget.selectDay.toString()];
        }else{
          if (i == 0) {
            selectedArr.add(pickerData[0]['subDatas'][lastYearIndex].toString());
          }else if (i == 1) {
            selectedArr.add(pickerData[1]['subDatas'][lastMonthIndex].toString());
          }else if (i == 2) {
            selectedArr.add(pickerData[2]['subDatas'][lastDayIndex].toString());
          }else{
            print('hehe');
          }
        }
      }else{
        selectedArr.add(model['subDatas'][0].toString());
      }
      pickerColumnArr.add(
        _buildBottomPicker(
            CupertinoPicker(
              scrollController: _getCurrentController(i),
              itemExtent: 40.0,
              backgroundColor: this.pickerBackgroundColor,
              onSelectedItemChanged: (int index) {
                if (this.isDatePicker == true) {
                  if (i == 0) {
                    lastYearIndex = index;
                    widget.selectYear = pickerData[0]['subDatas'][index];
                  }else if (i == 1) {
                    lastMonthIndex = index;
                    widget.selectMonth = pickerData[1]['subDatas'][index];
                  }else{
                    lastDayIndex = index;
                    widget.selectDay = pickerData[2]['subDatas'][index];
                  }
                  _changeDays(pickerData[0]['subDatas'][lastYearIndex], pickerData[1]['subDatas'][lastMonthIndex], 2, i);
                  selectedArr[0] = pickerData[0]['subDatas'][lastYearIndex].toString();
                  selectedArr[1] = pickerData[1]['subDatas'][lastMonthIndex].toString();
                  selectedArr[2] = pickerData[2]['subDatas'][lastDayIndex].toString();
                  print(selectedArr.toString());
                }else{
                  selectedArr[i] = model['subDatas'][index].toString();
                }
              },
              children: List<Widget>.generate(model['subDatas'].length, (int index) {
                return Center(
                  child: _showText(i, model, index)
                );
              }),
            ),context
        ),
      );
    }
    return pickerColumnArr;
  }

  _getCurrentController(int index) {
    print(widget.selectYear.toString() + widget.selectMonth.toString() + widget.selectDay.toString() + 'hahahaha');
    if (index == 2) {
      //日
      if (this.isDatePicker == true && widget.selectDay > 0) {
        List dayList = pickerData[2]['subDatas'];
        for (var i = 0; i < dayList.length; i++) {
          int haveDay = dayList[i];
          if (haveDay == widget.selectDay) {
            this.lastDayIndex = i;
            break;
          }
        }
        return controller;
      }else{
        return new FixedExtentScrollController(initialItem: 0);
      }
    }else if (index == 1){
      //月
      if (this.isDatePicker == true && widget.selectMonth > 0) {
        List monthList = pickerData[1]['subDatas'];
        for (var i = 0; i < monthList.length; i++) {
          int haveMonth = monthList[i];
          if (haveMonth == widget.selectMonth) {
            this.lastMonthIndex = i;
            break;
          }
        }
        return new FixedExtentScrollController(initialItem: this.lastMonthIndex);
      }else{
        return new FixedExtentScrollController(initialItem: 0);
      }
    }else {
      //年
      if (this.isDatePicker == true && widget.selectYear > 0) {
        List yearList = pickerData[0]['subDatas'];
        for (var i = 0; i < yearList.length; i++) {
          int haveYear = yearList[i];
          if (haveYear == widget.selectYear) {
            this.lastYearIndex = i;
            break;
          }
        }
        return new FixedExtentScrollController(initialItem: this.lastYearIndex);
      }else{
        return new FixedExtentScrollController(initialItem: 0);
      }
    }
  }
  
  _showText(int column, Map model, int index) {
    if (this.isDatePicker == true) {
      if (column == 0) {
        return Text(model['subDatas'][index].toString() + '年');
      }else if(column == 1) {
        return Text(model['subDatas'][index].toString() + '月');
      }else {
        return Text(model['subDatas'][index].toString() + '日');
      }
    }else {
      return Text(model['subDatas'][index].toString());
    }
  }

  _changeDays(int year, int month, int dayColumn, int column) {
    setState(() {
      var dayArr = [];
      for (var i = 1; i <= getDaysNum(year, month); i++) {
        dayArr.add(i);
      }
      this.pickerData[dayColumn] = {'subDatas' : dayArr};
      if (column != 2) {
        controller.jumpTo(0);
        lastDayIndex = 0;
      }
    });
  }

  Widget _buttonVIew(BuildContext context) {
    return new Container(
      width: MediaQuery.of(context).size.width,
      height: 50.0,
      color: this.pickerBackgroundColor,
      child: new Row(
        children: <Widget>[
          Container(
            child: FlatButton(
              onPressed: () {
                print('点击取消');
                Navigator.pop(context);
              },
              child: new Text(
                '取消',
              ),
            ),
          ),
          Container (
            child: FlatButton(
              onPressed: () {
                print('点击完成' + this.selectedArr.toString());
                Navigator.pop(context);
                callBack(this.selectedArr);
              },
              child: new Text(
                '完成',
              ),
            ),
          ),
        ],
        mainAxisSize: MainAxisSize.max,
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
      ),
    );
  }

  Widget _buildBottomPicker(Widget picker, BuildContext context) {
    return Container(
      height: this.pickerHeight - 70.0,
      width: MediaQuery.of(context).size.width / this.pickerData.length,
      color: this.pickerBackgroundColor,
      child: DefaultTextStyle(
        style: TextStyle(
          color: this.pickerTextColor,
          fontSize: this.textSize,
        ),
        child: GestureDetector(
          key: Key('picker'),
          onTap: (){},
          child: SafeArea(
            top: false,
            child: picker,
          ),
        ),
      ),
    );
  }
}

class Wmhpicker {
  static const MethodChannel _channel =
      const MethodChannel('wmhpicker');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }
}
